Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.

Count the number of distinct islands. An island is considered to be the same as another if and only if one island can be translated (and not rotated or reflected) to equal the other.

Example 1:

11000
11000
00011
00011

Given the above grid map, return 1.

Example 2:

11011
10000
00001
11011

Given the above grid map, return 3.

Notice that:

11
1

and

 1
11

are considered different island shapes, because we do not consider reflection / rotation.

Note: The length of each dimension in the given grid does not exceed 50.

这道题让我们求不同岛屿的个数,是之前那道 Number of Islands 的拓展,难点是如何去判断两个岛屿是否是不同的岛屿,首先1的个数肯定是要相同,但是1的个数相同不能保证一定是相同的岛屿,比如例子2中的那两个岛屿的就不相同,就是说两个相同的岛屿通过平移可以完全重合,但是不能旋转。如何来判断呢,可以发现可以通过相对位置坐标来判断,比如使用岛屿的最左上角的1当作基点,那么基点左边的点就是 (0,-1),右边的点就是 (0,1), 上边的点就是 (-1,0),下面的点就是 (1,0)。则例子1中的两个岛屿都可以表示为 [(0,0), (0,1), (1,0), (1,1)],点的顺序是基点-右边点-下边点-右下点。通过这样就可以判断两个岛屿是否相同了,下面这种解法没有用数组来存,而是 encode 成了字符串,比如这四个点的数组就存为 "0_0_0_1_1_0_1_1_",然后把字符串存入集合 unordered_set 中,利用其自动去重复的特性,就可以得到不同的岛屿的数量啦,参见代码如下:

解法一:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
unordered_set<string> res;
vector<vector<bool>> visited(m, vector<bool>(n, false));
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] == && !visited[i][j]) {
set<string> s;
helper(grid, i, j, i, j, visited, s);
string t = "";
for (auto str : s) t += str + "_";
res.insert(t);
}
}
}
return res.size();
}
void helper(vector<vector<int>>& grid, int x0, int y0, int i, int j, vector<vector<bool>>& visited, set<string>& s) {
int m = grid.size(), n = grid[].size();
visited[i][j] = true;
for (auto dir : dirs) {
int x = i + dir[], y = j + dir[];
if (x < || x >= m || y < || y >= n || grid[x][y] == || visited[x][y]) continue;
string str = to_string(x - x0) + "_" + to_string(y - y0);
s.insert(str);
helper(grid, x0, y0, x, y, visited, s);
}
}
};

当然我们也可以不 encode 字符串,直接将相对坐标存入数组中,然后把整个数组放到集合 set 中,还是会去掉相同的数组,而且这种解法直接在 grid 数组上标记访问过的位置,写起来更加简洁了,参见代码如下:

解法二:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
set<vector<pair<int, int>>> res;
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] != ) continue;
vector<pair<int, int>> v;
helper(grid, i, j, i, j, v);
res.insert(v);
}
}
return res.size();
}
void helper(vector<vector<int>>& grid, int x0, int y0, int i, int j, vector<pair<int, int>>& v) {
int m = grid.size(), n = grid[].size();
if (i < || i >= m || j < || j >= n || grid[i][j] <= ) return;
grid[i][j] *= -;
v.push_back({i - x0, j - y0});
for (auto dir : dirs) {
helper(grid, x0, y0, i + dir[], j + dir[], v);
}
}
};

既然递归 DFS 可以,那么迭代的 BFS 就坐不住了,其实思路没什么区别,这种类似迷宫遍历的题都是一个套路,整体框架都很像,细枝末节需要改改就行了,参见代码如下:

解法三:

class Solution {
public:
vector<vector<int>> dirs{{,-},{-,},{,},{,}};
int numDistinctIslands(vector<vector<int>>& grid) {
int m = grid.size(), n = grid[].size();
set<vector<pair<int, int>>> res;
for (int i = ; i < m; ++i) {
for (int j = ; j < n; ++j) {
if (grid[i][j] != ) continue;
vector<pair<int, int>> v;
queue<pair<int, int>> q{{{i, j}}};
grid[i][j] *= -;
while (!q.empty()) {
auto t = q.front(); q.pop();
for (auto dir : dirs) {
int x = t.first + dir[], y = t.second + dir[];
if (x < || x >= m || y < || y >= n || grid[x][y] <= ) continue;
q.push({x, y});
grid[x][y] *= -;
v.push_back({x - i, y - j});
}
}
res.insert(v);
}
}
return res.size();
}
};

Github 同步地址:

https://github.com/grandyang/leetcode/issues/694

类似题目:

Number of Islands

Number of Distinct Islands II

参考资料:

https://leetcode.com/problems/number-of-distinct-islands/

https://leetcode.com/problems/number-of-distinct-islands/discuss/150037/DFS-with-Explanations

https://leetcode.com/problems/number-of-distinct-islands/discuss/108474/JavaC%2B%2B-Clean-Code

https://leetcode.com/problems/number-of-distinct-islands/discuss/108475/Java-very-Elegant-and-concise-DFS-Solution(Beats-100)

LeetCode All in One 题目讲解汇总(持续更新中...)

最新文章

  1. Thread比Task多出的无法代替的部分
  2. 关于line-height
  3. RCP:利用actionSet在菜单(menu)里添加内容
  4. [Hibernate] - mysql
  5. Docker 1.12.0将要发布的新功能
  6. GVIM:在WINDOWS下清爽写代码
  7. Android 生命周期 和 onWindowFocusChanged
  8. iw命令
  9. c - 冒泡/选择排序.
  10. 枚举与剪枝_观察算式(比标准答案还要牛B)
  11. Activity生命周期方法的调用顺序project与測试日志
  12. 《物联网框架ServerSuperIO教程》-19.设备驱动和OPC Client支持mysql、oracle、sqlite、sqlserver的持久化。v3.6.4版本发布
  13. Python: 你不知道的 super
  14. Vue Router学习笔记
  15. [No000014E]提问的智慧How To Ask Questions The Smart Way
  16. Java理论学时第六节。课后作业。
  17. Java 利用 poi 生成 Excel文件的通用例子
  18. Python 类的多态
  19. ./configure、make、make install 命令
  20. 如何写出格式优美的javadoc?

热门文章

  1. Spring Security 实战干货:使用 JWT 认证访问接口
  2. SpringDataSolr入门
  3. 后端必备的 Git 分支开发规范指南 转
  4. WPF 3D相机基本坐标简介
  5. DVWA-CSRF学习笔记
  6. C#,NPOI,Export Generic T Data
  7. WPF通过不透明蒙板切割显示子控件
  8. 邮箱图标的css样式
  9. Java并发包——线程安全的Map相关类
  10. Struts2 : action跳转时带参数跳转